/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:55:23 $
#include "constrs.h"

LBFA BS_variation( const RE& r ) {
	assert( r.class_invariant() );

	// Construct the homomorphic image of r.
	auto RFA l( r );

	// Construct the begin-marker.
	auto Reg<RFA> m;
	m.symbol( '$' );

	// Attach the begin-marker.
	m.concat( (const Reg<RFA>&)l );

	// Construct the dummy LBFA, for use with the non-homomorphic mapping
	// convert (Defn. 4.35 of the Taxonomy)
	auto LBFA LB;

	return( LB.convert( m ) );
}

RBFA BS_variation_dual( const RE& r ) {
	// See above.
	assert( r.class_invariant() );

	auto RFA l( r );

	// Construct the end-marker.
	auto Reg<RFA> m;
	m.symbol( '$' );

	// Attach the end-marker.
	((Reg<RFA>&)l).concat( m );

	auto RBFA RB;

	return( RB.convert( l ) );
}

