/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:56:46 $
#include "dsderem.h"

DSDeRemer DSDeRemer::out_transition( const CharRange a ) const {
	assert( class_invariant() );
	auto DSDeRemer ret( *this );
	ret.move_dots( a );
        ret.opt();
	return( ret );
}

void DSDeRemer::traverse_opt( const RE& r, int& node_num ) {
	assert( class_invariant() );
	assert( r.class_invariant() );
	// Recursively traverse r and apply the optimizations of Defn. 5.72
        // (function X) of the Taxonomy.
	switch( r.root_operator() ) {
	case EPSILON:
	case EMPTY:
	case SYMBOL:
		node_num++;
		break;        	
	case OR:
		before.unset_bit( node_num );
                // Fall through is good.
	case CONCAT:
		node_num++;
		traverse_opt( r.left_subexpr(), node_num );
		traverse_opt( r.right_subexpr(), node_num );
                break;
	case STAR:
		before.unset_bit( node_num );
		node_num++;
		after.unset_bit( node_num );
		traverse_opt( r.left_subexpr(), node_num );
                break;
	case PLUS:
	case QUESTION:
        	node_num++;
        	traverse_opt( r.left_subexpr(), node_num );
        	break;
        }
}

ostream& operator<<( ostream& os, const DSDeRemer& r ) {
	assert( r.class_invariant() );
	return( os << "\nDSDeRemer\n" << (const ISImpl&)r );
}

