/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:57:02 $
#include "dsdfarev.h"

CRSet DSDFARev::out_labels() const {
	assert( class_invariant() );
	auto CRSet a;

        // Go through all of the States to see which have transitions
	// into a State represented by this->which.
	auto State i;
	for( i = 0; i < which.domain(); i++ ) {
		a.combine( T->labels_between( i, which ) );
	}
        return( a );
}

DSDFARev DSDFARev::out_transition( const CharRange a ) const {
	assert( class_invariant() );

	auto StateSet result;
        // Set the correct domain.
	result.set_domain( which.domain() );

        // Find the reverse transitions by going through all State's.
	auto State i;
	for( i = 0; i < which.domain(); i++ ) {
		auto State j( T->transition_on_range( i, a ) );
		// We know that there's a transition from i to j on a.
		if( which.contains( j ) ) {
			// Then we want to add the reverse transition.
                        result.add( i );
                }
	}

        assert( class_invariant() );
        // Construct the abstract State on the way out of here:
	return( DSDFARev( result, T, S ) );
}

ostream& operator<<( ostream& os, const DSDFARev& r ) {
	os << "\nDSDFARev\n" << r.which << *r.T << *r.S << '\n';
        return( os );
}
