/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:57:16 $
#include "dsfa.h"

// A special constructor:
DSFA::DSFA( const StateSet& rq,
		const TransRel *rT,
		const StateRel *rE,
		const StateSet *rF ) :
			which( rE->closure( rq ) ),
			T( rT ),
			E( rE ),
			F( rF ) {
	assert( class_invariant() );
}

CRSet DSFA::out_labels() const {
	assert( class_invariant() );
        return( T->out_labels( which ) );
}

DSFA DSFA::out_transition( const CharRange a ) const {
	assert( class_invariant() );
	// Construct the abstract State on the way out of here:
	//	Assume that which is already E closed, then transition on CharRange
	//	a; the StateSet gets E closed again in the constructor.
	return( DSFA( T->transition_on_range( which, a ), T, E, F ) );
}

ostream& operator<<( ostream& os, const DSFA& r ) {
	os << "\nDSFA\n" << r.which << *r.T << *r.E << *r.F << '\n';
        return( os );
}
