/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:57:25 $
#include "dsis-opt.h"

DSIS_opt DSIS_opt::out_transition( const CharRange a ) const {
	assert( class_invariant() );
	auto DSIS_opt ret( *this );
	ret.move_dots( a );
	ret.opt();
	return( ret );
}

// Implement Definition 5.79
void DSIS_opt::traverse_opt( const RE& r, int& node_num ) {
	assert( class_invariant() );
	assert( r.class_invariant() );

	// Recursively traverse r and apply the optimizations of Defn. 5.79
	// (function Y) of the Taxonomy.
        // After will already have been cleared by DSIS_opt::opt()
	switch( r.root_operator() ) {
	case EPSILON:
	case EMPTY:
		before.unset_bit( node_num );
		node_num++;
                break;
	case SYMBOL:
		// Don't remove a bit before --- see Defintion 5.79
		node_num++;
		break;        	
	case OR:
	case CONCAT:
		before.unset_bit( node_num );
		node_num++;
		traverse_opt( r.left_subexpr(), node_num );
		traverse_opt( r.right_subexpr(), node_num );
                break;
	case STAR:
	case PLUS:
	case QUESTION:
        	before.unset_bit( node_num );
		node_num++;
        	traverse_opt( r.left_subexpr(), node_num );
        	break;
        }
}

ostream& operator<<( ostream& os, const DSIS_opt& r ) {
	assert( r.class_invariant() );
	return( os << "\nDSIS_opt\n" << (const ISImpl&)r );
}

