/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:57:33 $
#include "dslbfa.h"

// A special constructor:
DSLBFA::DSLBFA( const StateSet& rq,
		const Trans *rQmap_inverse,
		const StateRel *rfollow,
		const StateSet *rF ) :
			which( rq ),
			Qmap_inverse( rQmap_inverse ),
			follow( rfollow ),
			F( rF ) {
	assert( class_invariant() );
}

CRSet DSLBFA::out_labels() const {
	assert( class_invariant() );
	// *Qmap_inverse contains the transitions _into_ State's.
	// So, we take the image of which under follow to get which's out-transitions.
        return( Qmap_inverse->labels_into( follow->image( which ) ) );
}

// Pretty much follow the stuff in lbfa.cpp
DSLBFA DSLBFA::out_transition( const CharRange a ) const {
	assert( class_invariant() );
	return( DSLBFA( follow->image( which ).intersection(
			Qmap_inverse->range_transition( a ) ),
			Qmap_inverse,
			follow,
			F ) );
}

ostream& operator<<( ostream& os, const DSLBFA& r ) {
	os << "\nDSLBFA\n" << r.which << *r.Qmap_inverse << *r.follow << *r.F << '\n';
        return( os );
}
