/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:57:36 $
#include "dsrbfa.h"

// A special constructor:
DSRBFA::DSRBFA( const StateSet& rq,
		const Trans *rQmap_inverse,
		const StateRel *rfollow,
		const State rf ) :
			which( rq ),
			Qmap_inverse( rQmap_inverse ),
			follow( rfollow ),
			f( rf ) {
	assert( class_invariant() );
}

CRSet DSRBFA::out_labels() const {
	assert( class_invariant() );
        return( Qmap_inverse->labels_into( which ) );
}

// Pretty much follow the stuff in rbfa.cpp
DSRBFA DSRBFA::out_transition( const CharRange a ) const {
	assert( class_invariant() );
	return( DSRBFA( follow->image( Qmap_inverse->range_transition( a )
				.intersection( which ) ),
			Qmap_inverse,
			follow,
			f ) );
}

ostream& operator<<( ostream& os, const DSRBFA& r ) {
	os << "\nDSRBFA\n" << r.which << *r.Qmap_inverse << *r.follow << r.f << '\n';
        return( os );
}
