/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:57:53 $
#include "dtrans.h"


// Map the char to the next State.
State DTrans::operator[]( const char a ) const {
	assert( class_invariant() );
       	// Take first valid transition.
	auto int i;
	for( i = 0; i < in_use; i++ ) {
		if( transitions( i ).transition_label.contains( a ) ) {
                       	return( transitions( i ).transition_destination );
		}
	}
        assert( class_invariant() );
	return( Invalid );
}

State DTrans::range_transition( const CharRange a ) const {
	assert( class_invariant() );
       	// Take first valid transition.
	auto int i;
	for( i = 0; i < in_use; i++ ) {
		if( a <= transitions( i ).transition_label ) {
                       	return( transitions( i ).transition_destination );
		}
	}
        assert( class_invariant() );
	return( Invalid );
}

int DTrans::valid_out_transition( const CharRange a ) const {
	assert( class_invariant() );
	auto int i;
	for( i = 0; i < in_use; i++ ) {
		if( a <= transitions( i ).transition_label ) {
			return( 1 );
                }
	}
        assert( class_invariant() );
        return( 0 );
}

StateSet DTrans::range( int dom ) const {
	assert( class_invariant() );
	auto StateSet result;
	result.set_domain( dom );

	auto int i;
	for( i = 0; i < in_use; i++ ) {
		result.add( transitions( i ).transition_destination );
	}
        assert( class_invariant() );
        return( result );
}

ostream& operator<<( ostream& os, const DTrans& r ) {
	assert( r.class_invariant() );
        return( os << (TransImpl&)r );
}
