/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:57:57 $
#include "dtransre.h"

StateSet DTransRel::reverse_transition( const State r, const CharRange a ) const {
	assert( class_invariant() );
	assert( (0 <= r) && (r < domain()) );

	auto StateSet ret;
	ret.set_domain( domain() );
	auto State p;
	// Iterate over all of the States, and see which have transitions to r.
	for( p = 0; p < domain(); p++ ) {
		if( transition_on_range( p, a ) == r ) {
			ret.add( p );
		}
	}

	return( ret );
}

StateSet DTransRel::reverse_closure( const StateSet& r ) const {
	assert( class_invariant() );
	assert( r.class_invariant() );
	assert( domain() == r.domain() );

	auto StateSet result( r );
	auto StateSet intermediate;
	intermediate.set_domain( domain() );
	assert( intermediate.empty() );

	do {
		result.set_union( intermediate );
		intermediate.clear();

		// Go through the State's to see which can reach set result on
		// some transition.
		auto State st;
		for( st = 0; st < domain(); st++ ) {
			if( result.not_disjoint( lookup( st ).range( domain() ) ) ) {
				intermediate.add( st );
                        }
                }
        } while( !result.contains( intermediate ) );

        return( result );
}

void DTransRel::reincarnate() {
	assert( class_invariant() );
        // Don't reset the domain()
	auto int i;
	for( i = 0; i < domain(); i++ ) {
		map( i ).reincarnate();
        }
	StateTo<DTrans>::reincarnate();
        assert( class_invariant() );
}

