/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 15:59:58 $
#include "symrel.h"

SymRel& SymRel::identity() {
	assert( class_invariant() );
	// Iterate over the States, setting them to the identity.
	auto State p;
	for( p = 0; p < domain(); p++ ) {
		StateTo<StateSet>::map( p ).clear();
		StateTo<StateSet>::map( p ).add( p );
	}
	assert( class_invariant() );
	return( *this );
}

SymRel& SymRel::complement() {
	assert( class_invariant() );
	// Go through all of the StateSets and complement them.
	auto State p;
	for( p = 0; p < domain(); p++ ) {
		StateTo<StateSet>::map( p ).complement();
	}
	assert( class_invariant() );
	return( *this );
}

ostream& operator<<( ostream& os, const SymRel& r ) {
	assert( r.class_invariant() );
	return( os << (const StateRel &)r );
}

