/* (c) Copyright 1994 by Bruce W. Watson */
// $Revision: 1.1 $
// $Date: 1994/05/02 16:00:25 $

#include "re.h"
#include "sigma.h"
#include "fa.h"
#include "rfa.h"
#include "lbfa.h"
#include "rbfa.h"
#include "dsre.h"
#include "dfa.h"
#include "dconstrs.h"
#include "iconstrs.h"
#include <iostream.h>


main() {

	auto RE Z;
	cout << "\nEnter RE: " << endl;
	while( cin >> Z ) {
		cout << Z << endl;
/*
		cout << "Thompson's Sigma-alg:\n";
		auto Reg<FA> Th( Z );
    	cout << Th;
	    cout << Th.determinism();
*//*
    	cout << "Thompson's alg:\n";
	    auto FA Th2( Z );
    	cout << Th2;
	    cout << Th2.determinism();
    
    	cout << "Sigma-alg of RFA:\n";
	    auto Reg<RFA> R( Z );
    	cout << R;
	    cout << R.determinism();
        cout << R.determinism2();

	    cout << "RFA's:\n";
    	auto RFA R2( Z );
	    cout << R2;
    	cout << R2.determinism();
        cout << R2.determinism2();
    
	    cout << "LBFA's:\n";
    	auto LBFA L( R );
    	cout << L;
    	cout << L.determinism();

	    cout << "RBFA's:\n";
    	auto RBFA RB( R2 );
    	cout << RB;
    	cout << RB.determinism();

	    cout << "Brz0 DFA:\n";
    	auto DFA Brz0( Brz( Z ) );
    	cout << Brz0;

	    cout << "Brz1 DFA:\n";
    	auto DFA Brz1( Brz_optimized( Z ) );
	    cout << Brz1;
*/

    	cout << "Iconstr DFA:\n";
	    auto DFA I( Iconstr( &Z ) );
    	cout << I;

	cout << I.Usefulf() << endl;
	cout << I.usefulf();
	cout << I.Usefulf() << endl;

	auto DFA I_asu( I );
	auto DFA I_hu( I );
	auto DFA I_hop( I );
	auto DFA I_bww( I );

	cout << I.min_Brzozowski();
	cout << I_asu.min_dragon();
	cout << I_hu.min_HopcroftUllman();
	cout << I_hop.min_Hopcroft();
	cout << I_bww.min_Watson();


/*
	    I = DeRemer( &Z );
    	cout << "DeRemer DFA:\n" << I;

	    I = Oconstr( &Z );
    	cout << "Oconstr DFA:\n" << I;
*/
	    cout << "\nEnter RE: " << flush;
}

	return( 0 );
}
